@import model._

@import model.forms.UmpireAssignmentForm
@(umpires: Seq[UserWithPlayer], availableGames: Seq[GameWithTeams], currentAssignments: Seq[(GameWithTeams, Option[UserWithPlayer])], form: Form[UmpireAssignmentForm])(implicit req: MessagesRequest[AnyContent], user: User)

@implicitField = @{
    helper.FieldConstructor(views.html.templates._field_constructor.f)
}

<!DOCTYPE html>

<html lang="en">
    <head>
    @views.html.templates._common_headers("Umpire Assignments")
    </head>
    <body>
        @views.html.templates._navbar()(req, Some(user))

        <div class="container">
            <h3>Current Assignments</h3>
            <hr />
            @helper.form(action = routes.AdminController.submitUmpireAssignmentForm()) {
                @if(form.hasGlobalErrors && form.data.get("addition").contains("true")) {
                    @for(error <- form.globalErrors) {
                        @for(msg <- error.messages) {
                            <p class="text-danger">@msg</p>
                        }
                    }
                }
                <div class="row mb-2">
                    <div class="col-sm">
                    @helper.input(form("umpire")) { (id, name, value, args) =>
                        <select name="@name" id="@id" class="custom-select" required="required">
                        @for(ump <- umpires.sortBy(up => up.player.map(_.fullName).getOrElse(up.user.redditName).toLowerCase)) {
                            @if(form.data.get("addition").contains("true") && value.contains(ump.user.redditName)) {
                                <option value="@ump.user.redditName" selected="selected">@ump.player.map(_.fullName + s" (${ump.user.redditName})").getOrElse(ump.user.redditName)</option>
                            } else {
                                <option value="@ump.user.redditName">@ump.player.map(_.fullName + s" (${ump.user.redditName})").getOrElse(ump.user.redditName)</option>
                            }
                        }
                        </select>
                    }
                    </div>
                    <div class="col-sm mt-2 mt-sm-0">
                    @helper.input(form("game")) { (id, name, value, args) =>
                        <select name="@name" id="@id" class="custom-select" required>
                        @for(game <- availableGames) {
                            @if(form.data.get("addition").contains("true") && value.contains(game.game.id.toString)) {
                                <option value="@game.game.id" selected>@game.name</option>
                            } else {
                                <option value="@game.game.id">@game.name</option>
                            }
                        }
                        </select>
                    }
                    </div>
                    <div class="col-sm mt-2 mt-sm-0">
                    @helper.input(form("addition")) { (_, name, _, _) =>
                        <button class="btn btn-success" name="@name" value="true">Assign</button>
                    }
                    </div>
                </div>
            }
            <ul id="ua-tab-selector" class="nav nav-tabs" role="tablist">
                <li class="nav-item">
                    <a class="nav-link active" data-toggle="tab" href="#mlr">MLR</a>
                </li>
                <li class="nav-item ml-2">
                    <a class="nav-link" data-toggle="tab" href="#milr">MiLR</a>
                </li>
            </ul>
            <div id="ua-tab-content" class="tab-content">
                @for((milr, assignmentSet) <- currentAssignments.groupBy(_._1.game.milr)){
                    <div class="tab-pane fade @{if (!milr) "show active" else ""}" id="@{if (milr) "milr" else "mlr"}">
                        <div class="table-responsive-sm">
                            <table class="table table-striped table-hover table-sm">
                                <thead>
                                    <tr>
                                        <th>Umpire</th>
                                        <th>Player</th>
                                        <th>Game</th>
                                        <th>Remove?</th>
                                    </tr>
                                </thead>
                                <tbody>
                                @for((game, uP) <- assignmentSet.filter(_._2.isDefined).sortBy(_._1.game.id)) {
                                    <tr>
                                        <td>@uP.get.user.redditName</td>
                                        <td>@uP.get.player.map(_.fullName).getOrElse("None")</td>
                                        <td>@game.game.season.@game.game.session @game.awayTeam.tag @@ @game.homeTeam.tag</td>
                                        <td>
                                            <form action="@routes.AdminController.submitUmpireAssignmentForm()" method="POST">
                                                <input hidden="hidden" name="umpire" value="@uP.get.user.redditName"/>
                                                <input hidden="hidden" name="game" value="@game.game.id"/>
                                                <button class="btn btn-danger" type="submit" name="addition" value="false">&times;</button>
                                            </form>
                                        </td>
                                    </tr>
                                }
                                </tbody>
                            </table>
                        </div>
                    </div>
                }
            </div>
        </div>
    </body>
</html>
